/* Program pro ovladani ctyr motoru s radicem L293D s 74HC595
 * pro ovladani auticka s Mecanum Omni-koly nebo obycejnymi 
 * zadavani volby chodu motoru, smeru otaceni a rychlosti je z tabletu 
 * nebo telefonu terminalem pro seriovou komunikaci. 
 * vagnervlastimil@seznam.cz
 * www.mojeelektronika.mzf.cz
 */
#include <SoftwareSerial.h>   // prihrani knihovny pro komunikaci s bluetooth
SoftwareSerial BT(2,13);      // nastaveni komunikacnich pinu PIN2 RXD, PIN13 TXD na Arduninu
#define potvrd 12             // PIN12 DPS Arduino UNO potvrzeni dat PIN 12 RCLK 74HC595 
#define clk 4                 // clk PIN4 DPS Arduino UNO takt pro posun bitu PIN 11 74HC595 
#define data 8                // PIN8 DPS Arduino UNO seriovy vstup dat do 74HC595 PIN 14 
#define prvnimotor 11         // vystupni pin11 ANALOGWRITE ARDUINO ENABLE MOTOR1,INPUT1 IO1 PWM
#define druhymotor 3          // vystupni pin3 ANALOGWRITE ARDUINO ENABLE MOTOR2,INPUT2 IO1 PWM 
#define tretimotor 6          // vystupni pin6 ANALOGWRITE ARDUINO ENABLE MOTOR3,INPUT1 IO2 PWM
#define ctvrtymotor 5         // vystupni pin5 ANALOGWRITE ARDINO ENABLE MOTOR4,INPUT2 IO2 PWM
#define povolit 7             // vystupni pin7 vstup 13 74HC595 ovlada vstup OE 
int hodnota;                  // definovani promenne pro data do 74HC505
int pwm1, pwm2, pwm3, pwm4;   // promenne pro hodnoty PWM
// promenne hodnota, PWM1 motor1, PWM2 motor2, PWM3 motor3, PWM4 motor4 

void setup() {                       // zadani parametru
BT.begin(9600);                      // nastaveni pro komunikaci Arduina s bluetooth
pinMode(potvrd, OUTPUT);             // nastaveni PINU 3 na vystup
pinMode(clk, OUTPUT);                // nastaveni PINU 4 na vystup 
pinMode(data, OUTPUT);               // nastaveni PINU 2 na vystup
pinMode(prvnimotor, OUTPUT);         // vystup PWM motoru1
pinMode(druhymotor,OUTPUT);          // vystup PWM motoru2
pinMode(tretimotor,OUTPUT);          // vystup PWM motor3
pinMode(ctvrtymotor,OUTPUT);         // vystup PWM motor4
pinMode(povolit,OUTPUT);             // vstup 13 OE 74HC595 povoli zapis pri LOW
digitalWrite(povolit,LOW);           // vypnuti vystupu pro ovladani vstupu OE 74HC595
delay(20);                           // casova prodleva po nastaveni OE13 na LOW
digitalWrite(potvrd, LOW);           // nastaveni potvrzeni dat na LOW umozni zapis dat
delay(10);                           // casova prodleva po vypnuti vstupu OE
shiftOut(data,clk,MSBFIRST,0);       // odeslani dat do 74HC595
delay(10);                           // casova prodleva
digitalWrite(potvrd,HIGH);           // zapnuti pinu potvrzeni dat  
analogWrite(prvnimotor,0);           // hodnota pro otacky prvniho motoru 
analogWrite(druhymotor,0);           // hodnota pro otacky druheho motoru 
analogWrite(tretimotor,0);           // hodnota pro otacky tretiho motoru
analogWrite(ctvrtymotor,0);          // hodnota pro otacky ctvrteho motoru
delay(500);                          // casova prodleva pro vypnuti motoru
}

void loop(){                         // hlavni program
if (BT.available() > 0){             // testovani vstupu zda prisli data   
smer();                              // zavolani prodprogramu pro vypnuti motoru
hodnota=BT.parseInt();               // nacteni hodnoty pro 74HC595 a ulozeni do promenne cti.
pwm1=BT.parseInt();                  // nacteni hodnoty pro prvni motor PWM
pwm2=BT.parseInt();                  // nacteni hodnoty pro druhy motor PWM
pwm3=BT.parseInt();                  // nacteni hosnoty pro treti motor PWM
pwm4=BT.parseInt();                  // nacteni hodnoty pro ctvrty motor PWM
digitalWrite(potvrd, LOW);           // nastaveni potvrzeni dat na LOW umozni zapis dat
delay(10);                           // casova prodleva po vypnuti vstupu OE
shiftOut(data,clk,MSBFIRST,hodnota); // odeslani dat do 74HC595
delay(10);                           // casova prodleva
digitalWrite(potvrd,HIGH);           // zapnuti pinu potvrzeni dat
analogWrite(prvnimotor, pwm1);       // hodnota pro otacky prvniho motoru 
analogWrite(druhymotor, pwm2);       // hodnota pro otacky druheho motoru 
analogWrite(tretimotor, pwm3);       // hodnota pro otacky tretiho motoru
analogWrite(ctvrtymotor, pwm4);      // hodnota pro otacky ctvrteho motoru
BT.print("74HC595 : ");              // odeslani "hodnoty :" do terminalu v PC
BT.println(hodnota);                 // odeslani nactene hodnoty v promenne "hodnota" do terminalu v PC
BT.print("prvni motor : ");          // cislo motoru
BT.println(pwm1);                    // hodnota pro PWM prvni motor
BT.print("druhy motor : ");          // cislo motoru
BT.println(pwm2);                    // hodnota pro PWM druhy motor
BT.print("treti motor : ");          // cislo motoru
BT.println(pwm3);                    // hodnota pro PWM treti motor
BT.print("ctvrty motor : ");         // cislo motoru
BT.println(pwm4);                    // hodnota pro PWM ctvrty motor
BT.println();                        // odradkovani na dalsi radek
  } 
}

void smer(){                         // podprogram
digitalWrite(potvrd, LOW);           // nastaveni potvrzeni dat na LOW umozni zapis dat
delay(10);                           // casova prodleva po vypnuti vstupu OE
shiftOut(data,clk,MSBFIRST,0);       // odeslani dat do 74HC595
delay(10);                           // casova prodleva
digitalWrite(potvrd,HIGH);           // zapnuti pinu potvrzeni dat  
analogWrite(prvnimotor,0);           // hodnota pro otacky prvniho motoru 
analogWrite(druhymotor,0);           // hodnota pro otacky druheho motoru 
analogWrite(tretimotor,0);           // hodnota pro otacky tretiho motoru
analogWrite(ctvrtymotor,0);          // hodnota pro otacky ctvrteho motoru
delay(200);                          // casova prodleva pro vypnuti motoru
}                                    // konec smycky 


    
